<template>
  <div
    @click="
      authenticated ? handleGameClick(gameForDisplay) : toggleLoginRegisterDialog()
    "
    class="w-full aspect-[26/37] relative">
    <!--<div class="w-full h-full relative">-->
      <div :class="' absolute bottom-[26px] w-full z-50'">
        <div class="items-center justify-center flex">
          <img
            :src="gameForDisplay.ProviderLogoCenterPath"
            class="h-[26px] w-[70px] m-auto object-contain"
            @error="(e) => e.target.remove()"
          />
        </div>
      </div>
      <div class="flex flex-col absolute left-2 top-2 items-start p-0 gap-1 z-40">
        <div v-if="!gameForDisplay.IsHotGame" class="w-8 h-[11.2px]">
          <SvgIcon svg-name="badge-hot-game-product-category" />
        </div>
        <div v-if="!gameForDisplay.IsNewGame" class="w-8 h-[11.2px]">
          <SvgIcon svg-name="badge-new-game-product-category" />
        </div>
      </div>
      <div class="absolute h-full w-full z-20 top-1">
        <img
          class="h-[96px] w-[94px] m-auto object-contain"
          src="assets/images/background-product-category-deco.png"/>
      </div>
      <div class="absolute w-[104px] h-[90.85px] z-10 top-11 left-1 overflow-hidden border border-[#4D5080] rounded-lg bg-background5">
      <div class="overflow-hidden relative h-full w-full bg-background5">
          <img
            class="absolute w-full h-full object-cover"
            src="assets/images/football-stadium-background.png" />
          <img
              class="w-[110px]"
              src="assets/images/bg_effect_product_category_loby.png"/>
      </div>
      </div>
      <div class="absolute w-[104px] h-[40px] z-40 bottom-[22px] left-1 overflow-hidden border border-b-0 border-t-0 border-[#4D5080] rounded-lg rounded-t-none">
        <div class="fading-bg h-full w-full"></div>
      </div>
      <div class="absolute top-2 justify-start items-start flex-col z-30 w-full">
        <div class="w-[104px] m-auto relative">
          <img
            :src="gameForDisplay.StarImagePath"
            class="w-full h-full m-auto object-contain"
            @error="
            (e) =>
                isHandleDefaultImageRender(gameForDisplay.StarImagePath)
                  ? onErrorDefaultImage(e, gameForDisplay.StarImagePath)
                  : e.target.remove()
            "
        />
        </div>
      </div>
    <!--</div>-->
    <!--<div
      v-if="isMultipleProvider"
      class="flex items-center w-full justify-center -mt-4">
      <span class="game-name align-middle">{{ gameForDisplay.GameName }}</span>
    </div>-->
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, PropType } from "vue";
import { store } from "@/store";
import { IGameBsi } from "@/models/bsiGameList";
import commonHelper from "@/utils/commonHelper";
import { handleGameEntryOpenWindow } from "@/composables/useTheme";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import CockFightDisplayModel from "~~/models/cockFightModel";
import { IGame } from "@/models/IGetPlayableGamesResponse";
import SportDisplayModel from "~~/components/sport/sportDisplayModel";

export default defineComponent({
  props: {
    game: {
      type: Object as PropType<IGameBsi>,
      required: true,
    },
    isMultipleProvider: {
      type: Boolean,
      required: true,
    },
  },
  setup(props) {
    const authenticated = computed(() => store.state.auth);
    const { getAssetImage, onErrorDefaultImage, isHandleDefaultImageRender, toggleLoginRegisterDialog } = commonHelper;
    const gameForDisplay = computed(() => new SportDisplayModel(props.game));
    const config = useRuntimeConfig();
    const router = useRouter();
    const route = useRoute();
    const handleGameClick = (game: IGame) => {
      const isDemo = config.public.CURRENTLY_ENV === "demo";
      const isWebId8 = store.state.webId === 8;
      const isSportPage = route.path.includes("/sports");
      const isMainTheme = store.state.selectedThemeName === "main";
      if (isDemo && isWebId8 && isSportPage && isMainTheme) {
        const location = EnumEntranceLocation.GameLobby;
        router.push(`/game/${game.GameId}?location=${location}&silent`);
      } else {
        handleGameEntryOpenWindow(game, 550, 850);
      }
    };
    const getCockFightBackgroundMobileImage = (game: IGameBsi) => {
      const imageForDisplay = computed(() => new CockFightDisplayModel(game));
      const startImage = imageForDisplay.value.backgroundMobilePath;
      return startImage;
    }
    return {
      authenticated,
      getAssetImage,
      gameForDisplay,
      handleGameEntryOpenWindow,
      onErrorDefaultImage,
      isHandleDefaultImageRender,
      handleGameClick,
      toggleLoginRegisterDialog,
      getCockFightBackgroundMobileImage,
    };
  },
});
</script>

<style scoped>
.fading-bg {
  background: linear-gradient(0deg, #0B0E30 41.89%, rgba(11, 14, 48, 0) 100%);
}

.game-name {
  font-family: Roboto;
  font-size: 12px;
  font-weight: 700;
  line-height: 14.06px;
  text-align: center;
  color: var(--text2);
}
</style>

<div class="flex flex-col absolute left-2 top-2 items-start p-0 gap-1 z-40">
  <div v-if="!gameForDisplay.IsHotGame" class="w-8 h-[11.2px]">
    <img
      class="w-full h-full"
      src="assets/images/category_tags.png"
    />
  </div>
  <div v-if="!gameForDisplay.IsNewGame" class="w-8 h-[11.2px]">
    <img
      class="w-full h-full"
      src="assets/images/category_tag_new.png"
    />
  </div>
</div>